using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace Citi.SpreadEngine.UserControls
{
	/// <summary>
	/// Summary description for OverrideSettingsControl.
	/// </summary>
	public class OverrideSettingsControl : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Panel _mainPanel;
		//private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.ComboBox _cbxOverrideSpread;
		private System.Windows.Forms.CheckBox _chbxAutoExec;
		private System.Windows.Forms.CheckBox _chbxMarketOnOff;
		private System.Windows.Forms.Label _lblOverrideSize;
		private System.Windows.Forms.Label _lblOverrideSpread;
		private System.Windows.Forms.Label _lblAutoExec;
		private System.Windows.Forms.Label _lblMarketOnOff;
		private System.Windows.Forms.ComboBox _cbxOverrideSize;
		private GridDataBoundGrid _dataGrid;
		private Citi.Cache.Cache _cache;
		private System.Windows.Forms.TextBox _txtSpreadValue;
		private System.Windows.Forms.TextBox _txtSizeValue;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OverrideSettingsControl(GridDataBoundGrid dataGrid_)
		{
			_dataGrid = dataGrid_;

			// Can work out background color from the CurrentCell value
			/////_dataGrid.CurrentCell
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			InitializeStrategies();

			InitializeSizes();

			_cache = Cache.Cache.Instance;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this._mainPanel = new System.Windows.Forms.Panel();
			this._cbxOverrideSpread = new System.Windows.Forms.ComboBox();
			this._chbxAutoExec = new System.Windows.Forms.CheckBox();
			this._chbxMarketOnOff = new System.Windows.Forms.CheckBox();
			this._lblOverrideSize = new System.Windows.Forms.Label();
			this._lblOverrideSpread = new System.Windows.Forms.Label();
			this._lblAutoExec = new System.Windows.Forms.Label();
			this._cbxOverrideSize = new System.Windows.Forms.ComboBox();
			this._lblMarketOnOff = new System.Windows.Forms.Label();
			this._txtSpreadValue = new System.Windows.Forms.TextBox();
			this._txtSizeValue = new System.Windows.Forms.TextBox();
			this._mainPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// _mainPanel
			// 
			this._mainPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this._mainPanel.Controls.Add(this._txtSizeValue);
			this._mainPanel.Controls.Add(this._txtSpreadValue);
			this._mainPanel.Controls.Add(this._cbxOverrideSpread);
			this._mainPanel.Controls.Add(this._chbxAutoExec);
			this._mainPanel.Controls.Add(this._chbxMarketOnOff);
			this._mainPanel.Controls.Add(this._lblOverrideSize);
			this._mainPanel.Controls.Add(this._lblOverrideSpread);
			this._mainPanel.Controls.Add(this._lblAutoExec);
			this._mainPanel.Controls.Add(this._cbxOverrideSize);
			this._mainPanel.Controls.Add(this._lblMarketOnOff);
			this._mainPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this._mainPanel.ForeColor = System.Drawing.Color.Navy;
			this._mainPanel.Location = new System.Drawing.Point(0, 0);
			this._mainPanel.Name = "_mainPanel";
			this._mainPanel.Size = new System.Drawing.Size(300, 80);
			this._mainPanel.TabIndex = 0;
			this._mainPanel.Paint += new System.Windows.Forms.PaintEventHandler(this._mainPanel_Paint);
			// 
			// _cbxOverrideSpread
			// 
			this._cbxOverrideSpread.Location = new System.Drawing.Point(112, 32);
			this._cbxOverrideSpread.Name = "_cbxOverrideSpread";
			this._cbxOverrideSpread.Size = new System.Drawing.Size(104, 21);
			this._cbxOverrideSpread.TabIndex = 6;
			this._cbxOverrideSpread.SelectedIndexChanged += new System.EventHandler(this._cbxOverrideSpread_SelectedIndexChanged);
			// 
			// _chbxAutoExec
			// 
			this._chbxAutoExec.Location = new System.Drawing.Point(224, 0);
			this._chbxAutoExec.Name = "_chbxAutoExec";
			this._chbxAutoExec.Size = new System.Drawing.Size(24, 24);
			this._chbxAutoExec.TabIndex = 5;
			this._chbxAutoExec.CheckedChanged += new System.EventHandler(this._chbxAutoExec_CheckedChanged);
			// 
			// _chbxMarketOnOff
			// 
			this._chbxMarketOnOff.Location = new System.Drawing.Point(112, 0);
			this._chbxMarketOnOff.Name = "_chbxMarketOnOff";
			this._chbxMarketOnOff.Size = new System.Drawing.Size(19, 24);
			this._chbxMarketOnOff.TabIndex = 4;
			this._chbxMarketOnOff.CheckedChanged += new System.EventHandler(this._chbxMarketOnOff_CheckedChanged);
			// 
			// _lblOverrideSize
			// 
			this._lblOverrideSize.Location = new System.Drawing.Point(8, 56);
			this._lblOverrideSize.Name = "_lblOverrideSize";
			this._lblOverrideSize.Size = new System.Drawing.Size(100, 16);
			this._lblOverrideSize.TabIndex = 3;
			this._lblOverrideSize.Text = "Override Size";
			this._lblOverrideSize.Click += new System.EventHandler(this._lblOverrideSize_Click);
			// 
			// _lblOverrideSpread
			// 
			this._lblOverrideSpread.Location = new System.Drawing.Point(8, 32);
			this._lblOverrideSpread.Name = "_lblOverrideSpread";
			this._lblOverrideSpread.Size = new System.Drawing.Size(100, 16);
			this._lblOverrideSpread.TabIndex = 2;
			this._lblOverrideSpread.Text = "Override Spread";
			this._lblOverrideSpread.Click += new System.EventHandler(this._lblOverrideSpread_Click);
			// 
			// _lblAutoExec
			// 
			this._lblAutoExec.Location = new System.Drawing.Point(152, 8);
			this._lblAutoExec.Name = "_lblAutoExec";
			this._lblAutoExec.Size = new System.Drawing.Size(56, 16);
			this._lblAutoExec.TabIndex = 1;
			this._lblAutoExec.Text = "Auto Exec";
			this._lblAutoExec.Click += new System.EventHandler(this._lblAutoExec_Click);
			// 
			// _cbxOverrideSize
			// 
			this._cbxOverrideSize.Location = new System.Drawing.Point(112, 56);
			this._cbxOverrideSize.Name = "_cbxOverrideSize";
			this._cbxOverrideSize.Size = new System.Drawing.Size(104, 21);
			this._cbxOverrideSize.TabIndex = 7;
			this._cbxOverrideSize.SelectedIndexChanged += new System.EventHandler(this._cbxOverrideSize_SelectedIndexChanged);
			// 
			// _lblMarketOnOff
			// 
			this._lblMarketOnOff.Location = new System.Drawing.Point(8, 8);
			this._lblMarketOnOff.Name = "_lblMarketOnOff";
			this._lblMarketOnOff.Size = new System.Drawing.Size(100, 16);
			this._lblMarketOnOff.TabIndex = 0;
			this._lblMarketOnOff.Text = "Market On/Off";
			this._lblMarketOnOff.Click += new System.EventHandler(this._lblMarketOnOff_Click);
			// 
			// _txtSpreadValue
			// 
			this._txtSpreadValue.Location = new System.Drawing.Point(224, 32);
			this._txtSpreadValue.Name = "_txtSpreadValue";
			this._txtSpreadValue.Size = new System.Drawing.Size(72, 20);
			this._txtSpreadValue.TabIndex = 8;
			this._txtSpreadValue.Text = "";
			// 
			// _txtSizeValue
			// 
			this._txtSizeValue.Location = new System.Drawing.Point(224, 56);
			this._txtSizeValue.Name = "_txtSizeValue";
			this._txtSizeValue.Size = new System.Drawing.Size(72, 20);
			this._txtSizeValue.TabIndex = 9;
			this._txtSizeValue.Text = "";
			// 
			// OverrideSettingsControl
			// 
			this.BackColor = System.Drawing.Color.White;
			this.Controls.Add(this._mainPanel);
			this.Name = "OverrideSettingsControl";
			this.Size = new System.Drawing.Size(300, 80);
			this._mainPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void InitializeStrategies()
		{
			if(!this._cbxOverrideSize.Items.Contains("N/A"))
			{
				this._cbxOverrideSpread.Items.Add("N/A");
			}
			if(!this._cbxOverrideSize.Items.Contains("Static"))
			{
				this._cbxOverrideSpread.Items.Add("Static");
			}
			if(!this._cbxOverrideSize.Items.Contains("Liquidity"))
			{
				this._cbxOverrideSpread.Items.Add("Liquidity");
			}

			this._cbxOverrideSpread.SelectedText = "N/A";
		}

		private void InitializeSizes()
		{
			if(!this._cbxOverrideSize.Items.Contains("N/A"))
			{
				this._cbxOverrideSize.Items.Add("N/A");
			}
			if(!this._cbxOverrideSize.Items.Contains("Static"))
			{
				this._cbxOverrideSize.Items.Add("Static");
			}

			this._cbxOverrideSize.SelectedText = "N/A";
		}

		private void _chbxMarketOnOff_CheckedChanged(object sender, System.EventArgs e)
		{
			CheckBox cb = sender as CheckBox;
			
			int colIndex = _dataGrid.CurrentCell.ColIndex;
			int field = _dataGrid.Binder.ColIndexToField(colIndex);
			string mappingName = _dataGrid.GridBoundColumns[field].MappingName;

			// Need to get reference to data grid this is associated with so that
			// its cells can be modified.
			GridDataBoundGrid gdbg = (GridDataBoundGrid)_cache.RetrieveObject("SpreadEngineDataGrid");

			// Set a flag so that when PrepareView is called it knows to set cell to strike through
			Hashtable marketOn = new Hashtable();
			// Add keys in below Hashtable that correspond to applciable market
			// Shouldn't jsut Update MarketOverrideSettings either, should check to see if entry
			// and if so bring back hashtable then update that object.
			marketOn.Add("MarketOn", cb.Checked);
			// Check to ensure that this is not already in the cache
			if(_cache.ContainsKey("MarketOverrideSettings"))
				_cache.UpdateObject("MarketOverrideSettings", marketOn);	
			else
				_cache.AddObject("MarketOverrideSettings", marketOn);			
			int coreStrategyColIndex = gdbg.Binder.NameToField("CoreStrategy");
			int coreSizeColIndex = gdbg.Binder.NameToField("CoreSize");
			// Once for Strategy and once for Size
			gdbg.RefreshRange(GridRangeInfo.Col(coreStrategyColIndex+2));
			gdbg.RefreshRange(GridRangeInfo.Col(coreSizeColIndex+2));

			string sdsdsd = "";
		}

		private void _lblMarketOnOff_Click(object sender, System.EventArgs e)
		{
			string s = "";		
		}

		private void _cbxOverrideSize_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string s = "";		
		}

		private void _lblAutoExec_Click(object sender, System.EventArgs e)
		{
			string s = "";		
		}

		private void _lblOverrideSpread_Click(object sender, System.EventArgs e)
		{
			string s = "";		
		}

		private void _lblOverrideSize_Click(object sender, System.EventArgs e)
		{
			string s = "";
		}

		private void _chbxAutoExec_CheckedChanged(object sender, System.EventArgs e)
		{
			string s = "";
		}

		private void _cbxOverrideSpread_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string s = "";
		}

		private void _mainPanel_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			string s = "";
		}
	}
}
